﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Windows.Forms;
using Newtonsoft.Json;
using SimpleHttp;
using SuperSocket;
using SuperSocket.Common;
using SuperSocket.SocketBase;
using SuperSocket.SocketEngine;
using SuperWebSocket;
using SuperWebSocket.Config;
using SuperWebSocket.Protocol;
using System.Timers;
using NVorbis;
using NVorbis.NAudioSupport;
using NAudio;

namespace Silencesoft.ServidorSubasta
{
    public partial class Form1 : Form
    {

        private List<WebSocketSession> m_Sessions = new List<WebSocketSession>();
        private static WebServer srv;
        // private static WebSocketServer wss;
        private static SuperWebSocket.WebSocketServer wss;
        protected static ConcurrentDictionary<User, string> OnlineUsers = new ConcurrentDictionary<User, string>();
        private static int Count;
        private static bool OnPlay;
        private static bool Playing = false;
        private static int CurrentProduct;
        private static int status = -1;
        private static System.Timers.Timer aTimer = new System.Timers.Timer();
        private static System.Timers.Timer bTimer = new System.Timers.Timer();
        private static int CurrentAuction = 0;
        private static NVorbis.NAudioSupport.VorbisFileReader _reader;
        private static NAudio.Wave.WaveOut _waveOut;
        private static System.IO.Ports.SerialPort serialPort1 = new System.IO.Ports.SerialPort();

        public Form1()
        {
            InitializeComponent();
            // aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
            aTimer.Elapsed += OnTimedEvent;
            aTimer.Elapsed += OnAnotherTimedEvent;
            OnPlay = false;
            var path = Application.StartupPath;
            string gameFiles = path + "\\web";
            srv = new WebServer(8000, -1, gameFiles);
            // wss = new WebSocketServer(8001);
            srv.Start();

            SuperSocket.SocketBase.Config.RootConfig r = new SuperSocket.SocketBase.Config.RootConfig();

            SuperSocket.SocketBase.Config.ServerConfig s = new SuperSocket.SocketBase.Config.ServerConfig();
            s.Name = "SuperWebSocket";
            // s.ServiceName = "SuperWebSocket";
            s.Ip = "Any";
            s.Port = 8001;
            // s.Mode = SocketMode.Async;
            s.Mode = SocketMode.Tcp;

            s.Security = "tls";
            SuperSocket.SocketBase.Config.CertificateConfig cert = new SuperSocket.SocketBase.Config.CertificateConfig();

            string pathToBaseDir = System.IO.Directory.GetParent(Environment.CurrentDirectory).Parent.FullName;

            cert.FilePath = System.IO.Path.Combine(pathToBaseDir, "localhost.cer");
            // System.Diagnostics.Debug.Assert(System.IO.File.Exists(cert.FilePath));
            cert.Password = "";

            s.Certificate = cert;

            SuperSocket.SocketEngine.SocketServerFactory f = new SuperSocket.SocketEngine.SocketServerFactory();


            if (wss != null)
            {
                wss.Stop();
                wss = null;
            }

            SubProtocolConfigCollection Protocols = new SubProtocolConfigCollection();

            //SuperWebSocket.SubProtocol.BasicSubProtocol DefaultProtocol = new SuperWebSocket.SubProtocol.BasicSubProtocol;
            //WebSocketSession DefaultSession = new WebSocketSession();
            //DefaultSession.Items.Add("Sec-WebSocket-Protocol", "chat");
            SuperWebSocket.SubProtocol.ISubProtocol<WebSocketSession> subProtocol = new SuperWebSocket.SubProtocol.BasicSubProtocol("Sec-WebSocket-Protocol");

            wss = new WebSocketServer();
            /*
            wss.Setup(r, s, f);
            wss.NewSessionConnected += new SessionHandler<WebSocketSession>(ws_NewSessionConnected);
            wss.NewMessageReceived += new SessionHandler<WebSocketSession, string>(ws_NewMessageReceived);
            wss.NewDataReceived += new SessionHandler<WebSocketSession, byte[]>(ws_NewDataReceived);
            wss.Start();*/
            wss.Setup(8001);
            wss.NewSessionConnected += new SessionHandler<WebSocketSession>(ws_NewSessionConnected);
            wss.NewMessageReceived += new SessionHandler<WebSocketSession, string>(ws_NewMessageReceived);
            // wss.NewMessageReceived += ws_NewMessageReceived;
            wss.NewDataReceived += new SessionHandler<WebSocketSession, byte[]>(ws_NewDataReceived);
            wss.SessionClosed += new SessionHandler<WebSocketSession, SuperSocket.SocketBase.CloseReason>(ws_SessionClosed);
            wss.Start();
            
            // startServer();
            b_Server.Text = "Stop";

            serialPort1.PortName = "COM1"; //  "COM1";
            serialPort1.BaudRate = 9600;

            try
            {

                serialPort1.Open();
                if (serialPort1.IsOpen)
                {
                    Console.WriteLine("Port");
                }
                else
                {
                    Console.WriteLine("No Port");
                }
            }
            catch
            {
                Console.WriteLine("No Com Port");
            }



        }

        private static void movements(int command)
        {
            if (!serialPort1.IsOpen) return;

            byte[] data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x90, 0x40 };
            if (command == 1)
            data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x92, 0x40 }; // voz on
            else if(command ==2)
            data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x94, 0x40 }; // voz off
            else if (command == 3)
                data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x88, 0x40 }; // brazo
            else if (command == 4)
                data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x90, 0x40 }; // cabeza derecha
            else if (command == 5)
                data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x8e, 0x40 }; // cabeza medio derecha
            else if (command == 6)
                data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x8c, 0x40 }; // cabeza medio izquierda
            else if (command == 7)
                data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x8a, 0x40 }; // cabeza izquierda
            else if (command == 8)
            data = new byte[] { 0xf0, 0x06, 0x53, 0x33, 0x41, 0x86, 0x08, 0x40 }; // coke
            else if (command == 9)
                data = new byte[] { 0xf0, 0x06, 0x53, 0x33, 0x41, 0x86, 0x04, 0x40 }; // papas
            else if (command == 10)
                data = new byte[] { 0xf0, 0x06, 0x53, 0x33, 0x41, 0x86, 0x02, 0x40 }; // brownie
            else if (command == 11)
                data = new byte[] { 0xf0, 0x06, 0x53, 0x33, 0x41, 0x86, 0x01, 0x40 }; // perro
            else if (command == 12)
            data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x82, 0x40 }; // sube plataforma
            else if (command == 13)
                data = new byte[] { 0xf0, 0x05, 0x53, 0x33, 0x41, 0x84, 0x40 }; // baja plataforma

            serialPort1.Write(data, 0, data.Length);
            serialPort1.DiscardOutBuffer();
            return;
        }

        private void b_Server_Click_1(object sender, EventArgs e)
        {
            if (b_Server.Text == "Stop")
            {
                b_Server.Text = "Start";
                stopServer();
            }
            else
            {
                b_Server.Text = "Stop";
                startServer();
            }
        }

        private void startServer()
        {

            srv.Start();
            wss.Start();
        }

        private void stopServer()
        {
            srv.Stop();
            wss.Stop();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
            // button1.Enabled = false;
            Count = 30;
            label1.Text = Count.ToString();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            label1.Text = (--Count).ToString();

            if (Count == 0)
            {
                // button1.Enabled = true;
                timer1.Stop();
            }
        }

        public static bool IsJson(string input)
        {
            input = input.Trim();
            return input.StartsWith("{") && input.EndsWith("}")
                   || input.StartsWith("[") && input.EndsWith("]");
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (wss != null)
            {
                wss.Stop();
                wss = null;
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            // MessageBox.Show("exit...");
            Application.Exit();
            Environment.Exit(0);
        }

        private static string CreateUserId()
        {
            var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            var random = new Random();
            var result = new string(
                Enumerable.Repeat(chars, 4)
                          .Select(s => s[random.Next(s.Length)])
                          .ToArray());
            return result;
        }
     
		// WebSocket

        void ws_SessionClosed(WebSocketSession session, SuperSocket.SocketBase.CloseReason e)
        {
            var u = OnlineUsers.Keys.Where(o => o.Session.SessionID.ToString() == session.SessionID.ToString()).Single();
            string trash; // Concurrent dictionaries make things weird
            OnlineUsers.TryRemove(u, out trash);
            if (!String.IsNullOrEmpty(u.Name))
            {
                // var r = new Response { Type = ResponseType.Disconnect, Data = new { user.Name } };
                // Broadcast(JsonConvert.SerializeObject(r));
            }
            if (OnlineUsers.Count < 2)
            {
                CurrentAuction = 0;
                status = -1;
                OnPlay = false;
                Dictionary<string, dynamic> go = new Dictionary<string, dynamic>();
                go.Add("message", "disconnect");
                sendToAll(JsonConvert.SerializeObject(go));
            }
        }

        void ws_NewDataReceived(WebSocketSession session, byte[] e)
        {


            session.Send(e, 0, e.Length);
        }

        void ws_NewMessageReceived(WebSocketSession session, string e)
        {
            // session.Send("Message: " + e);
            dynamic json = JsonConvert.DeserializeObject(e);
            switch ((string)json.message)
            {
                case "login":
                    if (!OnPlay)
                        Register(json.alias.Value, session);
                    else
                    {
                        doError(session, "current game");
                    }
                    break;
                case "auto-join":
                    JoinRoom(json, session);
                    break;
                case "bid":
                    SaveBid(session, json.value);
                    break;
            }
        }

        private static void SaveBid(WebSocketSession session, dynamic value)
        {
            var u = OnlineUsers.Keys.Where(o => o.Session.SessionID.ToString() == session.SessionID.ToString()).Single();
            u.CurrentBid = value;

                Dictionary<string, string> response = new Dictionary<string, string>();
                response.Add("message", "bids");
            int i = 0;
            foreach (var pair in OnlineUsers)
            {
                i++;
                User tmp = pair.Key;
                response.Add("Player-" + i.ToString(), tmp.ID);
                response.Add("Bid-" + i.ToString(), tmp.CurrentBid);
            }
                sendToAll(JsonConvert.SerializeObject(response));

        }

        private static void doError(WebSocketSession session, string message)
        {

            Dictionary<string, string> response = new Dictionary<string, string>();
            response.Add("message", "error");
            response.Add("content", message);
            session.Send(JsonConvert.SerializeObject(response));
        }
   
        private static void Register(string position, WebSocketSession session)
        {
            var u = OnlineUsers.Keys.Where(o => o.Session.SessionID.ToString() == session.SessionID.ToString()).Single();
            string name = "Player-" + OnlineUsers.Count.ToString();
            u.Name = name;
            u.Position = position;
            u.ID = CreateUserId();
            Dictionary<string, string> response = new Dictionary<string, string>();
            response.Add("message", "login-ok");
            response.Add("alias", u.Name);
            response.Add("type", "0"); // connection
            session.Send(JsonConvert.SerializeObject(response));
            OnlineUsers[u] = name;
        }

        private static void JoinRoom(dynamic obj, WebSocketSession session)
        {

            var u = OnlineUsers.Keys.Where(o => o.Session.SessionID.ToString() == session.SessionID.ToString()).Single();
            var me = new User { Session = session };
            var gameName = obj.game;
            var gameInstance = obj.instance;
            var gameRoom = obj.room;

            Dictionary<string, dynamic> response = new Dictionary<string, dynamic>();
            response.Add("Type", "1"); // Connection
            response.Add("message", "join-ok");
            response.Add("game", obj.game);
            response.Add("instance", obj.instance);
            response.Add("room", obj.room);
           
            if (OnlineUsers.Count == 1)
                response.Add("host", "true");
            else
                response.Add("host", "false");

            session.Send(JsonConvert.SerializeObject(response));

            response = new Dictionary<string, dynamic>();
            response.Add("message", "peer-joined");
            response.Add("peerid", u.ID); // Connection
            response.Add("peeralias",  u.Name);
            session.Send(JsonConvert.SerializeObject(response));

            if (OnlineUsers.Count > 1 && !Form1.isPlaying())
                {
                    /* status = 0;
                    aTimer.Interval = 3000;
                    aTimer.Enabled = true;*/
                    PlayAudio("bienvenida");
                }
        }

        private static bool isPlaying()
        {
            return Playing;
        }

        public static void CounterForStart()
        {
            if (CurrentAuction == 1)
            {
                PlayAudio("gaseosa");
                ShowProduct(8);
            }
            else if (CurrentAuction == 2)
            {
                PlayAudio("perrocaliente");
                ShowProduct(11);
            }
            else if (CurrentAuction == 3)
            {
                PlayAudio("papas");
                ShowProduct(10);
            }
            else if (CurrentAuction == 4)
            {
                PlayAudio("brownie");
                ShowProduct(9);
            }
            aTimer.Interval = 10000;
            aTimer.Enabled = true;
            status = 1;
        }

        public static void sendToAll(string message)
        {
            foreach (WebSocketSession session in wss.GetAllSessions())
            {
                session.Send(message);
            }
        }

        void ws_NewSessionConnected(WebSocketSession session)
        {
            CurrentAuction = 0;
            // session.Send("Hello From C#!");
            // session.SendResponse("coco");
            var me = new User { Session = session };
            OnlineUsers.TryAdd(me, String.Empty);
            Dictionary<string, string> response = new Dictionary<string, string>();
            response.Add("message", "welcome");
            response.Add("protocolrev", "1");
            response.Add("version", "1.0");
            response.Add("name", "2am Multiplayer Server");
            response.Add("operator", "2am");
            response.Add("motd", "A new Server is Online.");
            session.Send(JsonConvert.SerializeObject(response));
            // {"message":"welcome","protocolrev":1,"version":"1.0","name":"Scirra Multiplayer Signalling Server","operator":"Scirra Ltd","motd":"Welcome to the official Scirra Multiplayer Signalling server!","clientid":"YTIK","ice_servers":["stun:stun.l.google.com:19302","stun:stun1.l.google.com:19302","stun:stun2.l.google.com:19302","stun:stun3.l.google.com:19302","stun:stun4.l.google.com:19302","stun:23.21.150.121"]}

        }

        // timer end 
        private static void OnTimedEvent(object source, ElapsedEventArgs e)
        {
            aTimer.Enabled = false;
            if (CurrentProduct != 0)
            {
                aTimer.Enabled = true;
                aTimer.Interval = 1000;
                return;
            }

            
            if (status == 0) //ready
            {
            dynamic data = new { Ok = "1" };
            Dictionary<string, dynamic> go = new Dictionary<string, dynamic>();
                if (CurrentAuction < 4)
                    go.Add("message", "ready");
                else
                    go.Add("message", "readyB");
            go.Add("Data", data);
            sendToAll(JsonConvert.SerializeObject(go));
            if (CurrentAuction >= 7) CurrentAuction = 0;
            CurrentAuction++;
            CounterForStart();
            }
            else if (status == 1) // play
            {
                OnPlay = true;
                dynamic data = new { Ok = "1" };
                Dictionary<string, dynamic> go = new Dictionary<string, dynamic>();
                go.Add("message", "start");
                go.Add("auction", CurrentAuction.ToString());
                go.Add("Data", data);
                sendToAll(JsonConvert.SerializeObject(go));
                aTimer.Enabled = true;
                aTimer.Interval = 1000;
                Count = 31;
                status = 2;
            }
            else if (status == 2) // timer count
            {
                Count -= 1;
                aTimer.Enabled = true;
                aTimer.Interval = 1000;
                // dynamic data = new { Time = count.ToString() };
                Dictionary<string, dynamic> go = new Dictionary<string, dynamic>();
                go.Add("message", "time");
                // go.Add("Data", data);
                go.Add("time", Count.ToString());
                sendToAll(JsonConvert.SerializeObject(go));
                if (Count <= 0)
                {
                    status = 3;
                }
            }
            else if (status == 3) // count finish
            {
                string winner = ReviewBids();
                Dictionary<string, dynamic> go = new Dictionary<string, dynamic>();
                go.Add("message", "winner");
                go.Add("winner", winner);
                go.Add("auction", CurrentAuction.ToString());
                sendToAll(JsonConvert.SerializeObject(go));
                status = 0;
                aTimer.Enabled = true;
                aTimer.Interval = 3000;
            }
        }

        private static string ReviewBids()
        {
            string winner = "";
            int prev = 0;
               foreach (var pair in OnlineUsers)
               {
                User tmp = pair.Key;
                int current = tmp.CurrentBid.ToInt32();
                if (current > prev)
                {
                    winner = tmp.ID;
                    prev = current;
                }

            }
            return winner;
        }

        /* Ogg Audio Files */
        // Wire this up to a button on your UI
        private static void PlayAudio(string FileName)
        {
            movements(1);
            Playing = true;
            var path = Application.StartupPath;
            string AudioFiles = path + "\\audios";
            string Audio = AudioFiles+"\\"+FileName+".ogg";

            _reader = new NVorbis.NAudioSupport.VorbisFileReader(Audio);

            _waveOut = new NAudio.Wave.WaveOut();
            _waveOut.PlaybackStopped += OnStoppedHandler;
            _waveOut.Init(_reader);
            _waveOut.Play();
        }

        private static void OnStoppedHandler(object sender, EventArgs e)
        {
            movements(2);
            Playing = false;
            _waveOut.PlaybackStopped -= OnStoppedHandler;
            _waveOut = null;

            _reader.Dispose();
            _reader = null;

        if (status == -1)
            {
                status = 0;
        aTimer.Interval = 1500;
        aTimer.Enabled = true;
            }
        }

        private static bool IsPlaying()
        { 
            return Playing;
        }

        private static void ShowProduct(int Product)
        {
            movements(13);
            CurrentProduct = Product;
            bTimer.Interval = 14;
            bTimer.Enabled = true;
        }

        private static void OnAnotherTimedEvent(object source, ElapsedEventArgs e)
        {
            if (CurrentProduct == 0)
            {
                movements(12);
                bTimer.Interval = 14;
            bTimer.Enabled = true;
            }
            else 
            {
            bTimer.Interval = 4;
            bTimer.Enabled = true;
            movements(CurrentProduct);
                CurrentProduct = 0;
            }
        }

        /// <summary>
        /// Holds the name and context instance for an online user
        /// </summary>
        public class User
        {
            public string Name = String.Empty;
            public string Position = String.Empty;
            public string ID = String.Empty;
            public string CurrentBid = String.Empty;
            public int WinCount = 0;
            public int Points = 0;
            public int Money = 10000;
            public WebSocketSession Session { get; set; }
            // public UserContext Context { get; set; }
        }

    }
}
