﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;
using System.Diagnostics;
using SimpleHttp;
using System.Web;

namespace Silencesoft.ServidorSubasta
{
    class WebServer : HttpServer
    {

        private string path;

        public WebServer(int port, int port_https, string start_path)
			: base(port, port_https)
		{
            path = start_path;
		}

        public override void handleGETRequest(HttpProcessor p)
        {
			try
			{
				string requestedPage = p.request_url.AbsolutePath.TrimStart('/');

                if (requestedPage.StartsWith("ws/"))
                {
                    string json = "{\"data\": [{\"content\": \"mew\",\"value\": 25}]}";
                    p.writeSuccess("application/json");
                    p.outputStream.Write(json);
                    return;
                }

                //if (requestedPage.EndsWith(".jpg") || requestedPage.EndsWith(".jpeg") || requestedPage.EndsWith(".png"))
				//{

                if (requestedPage.EndsWith(".htm") || requestedPage.EndsWith(".html"))
                {
                    string html = ReadTextFile(path + "\\" + requestedPage);
                if (string.IsNullOrEmpty(html) || html == "NO")
                {
                    p.writeFailure();
                    return;
                }
                p.writeSuccess("text/html");
                p.outputStream.Write(html);
                return;
                }
                else if (requestedPage.EndsWith(".jpg") || requestedPage.EndsWith(".jpeg") || requestedPage.EndsWith(".png"))
                {
                    byte[] imageData = ReadFile(path + "\\" + requestedPage);
                    if (requestedPage.EndsWith(".png"))
                        p.writeSuccess("image/png");
                    else if (requestedPage.EndsWith(".gif"))
                        p.writeSuccess("image/gif");
                    else if (requestedPage.EndsWith(".jpg") || requestedPage.EndsWith(".jpg"))
                        p.writeSuccess("image/jpeg");
                    else
                    {
                        p.writeFailure();
                        return;
                    }
                    p.outputStream.Flush();
                    p.rawOutputStream.Write(imageData, 0, imageData.Length);
                    return;
                }
                else if (requestedPage.EndsWith(".css"))
                {
                    string css = ReadTextFile(path + "\\" + requestedPage);
                    if (string.IsNullOrEmpty(css) || css == "NO")
                    {
                        p.writeFailure();
                        return;
                    }
                    p.writeSuccess("text/css");
                    p.outputStream.Write(css);
                    return;
                }
                else if (requestedPage.EndsWith(".js"))
                {
                    string js = ReadTextFile(path + "\\" + requestedPage);
                    if (string.IsNullOrEmpty(js) || js == "NO")
                    {
                        p.writeFailure();
                        return;
                    }
                    p.writeSuccess("text/javascript");
                    p.outputStream.Write(js);
                    return;
                }


            }
            catch (Exception ex)
            {
                //if (!p.isOrdinaryDisconnectException(ex))
                //    Logger.Debug(ex);
            }

        }

        public override void handlePOSTRequest(HttpProcessor p, StreamReader inputData)
        {
        }

        public override void stopServer()
        {
        }

        // http://www.codeproject.com/Questions/497031/FileplusStreamplustoplusByteplusArrayplusandplusAr
        // Sowraaj
        //Returns the byte array of the given file
        //Is this a right way to do? i need more efficient code
        //Which is better File Stream/Memory Stream
        private byte[] ReadFile(string filePath)
        {
            if (File.Exists(filePath))
            {
                FileStream fs = new FileStream(filePath, FileMode.Open, FileAccess.Read);
                int length = Convert.ToInt32(fs.Length);
                byte[] data = new byte[length];
                fs.Read(data, 0, length);
                fs.Close();
                return data;
            }
            else
                return null;
        }

        private string ReadTextFile(string filePath)
        {
            if (File.Exists(filePath))
            {
                StreamReader streamReader = new StreamReader(filePath);
                string text = streamReader.ReadToEnd();
                streamReader.Close();
                return text;
            }
            else
                return "";
        }
    
    }
}
